//
//  GS1BoxView.swift
//  GeometrySikenjo
//
//  Created by narita on 2018/04/03.
//  Copyright © 2018年 narita. All rights reserved.
//

import Cocoa

class GS1BoxView: NSView
{
    // MARK: - class methods
    
    // MARK: - init methods
    
    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods
    
    // MARK: - action methods
    
    // 垂直方向のレイアウト調整
    
    // 上辺に外接させる
    @IBAction func outsideTop(_ sender: Any?)
    {
        self.floatBox = self.floatBox.outsideTop(base:self.baseBox)
    }

    // 上辺に内接させる
    @IBAction func insideTop(_ sender: Any?)
    {
        self.floatBox = self.floatBox.insideTop(base:self.baseBox)
    }

    // 垂直方向にセンタリング
    @IBAction func centringVertical(_ sender: Any?)
    {
        self.floatBox = self.floatBox.centringVertical(base:self.baseBox)
    }

    // 底辺に内接させる
    @IBAction func insideBottom(_ sender: Any?)
    {
        self.floatBox = self.floatBox.insideBottom(base:self.baseBox)
    }

    // 底辺に外接させる
    @IBAction func outsideBottom(_ sender: Any?)
    {
        self.floatBox = self.floatBox.outsideBottom(base:self.baseBox)
    }
    
    // 水平方向のレイアウト調整

    // 左辺に外接させる
    @IBAction func outsideLeft(_ sender: Any?)
    {
        self.floatBox = self.floatBox.outsideLeft(base:self.baseBox)
    }
    
    // 右辺に内接させる
    @IBAction func insideLeft(_ sender: Any?)
    {
        self.floatBox = self.floatBox.insideLeft(base:self.baseBox)
    }

    // 水平方向にセンタリングさせる
    @IBAction func centringHorizontal (_ sender: Any?)
    {
        self.floatBox = self.floatBox.centringHorizontal(base:self.baseBox)
    }
    
    // 右辺に内接させる
    @IBAction func insideRight(_ sender: Any?)
    {
        self.floatBox = self.floatBox.insideRight(base:self.baseBox)
    }
    
    // 右辺に外接させる
    @IBAction func outsideRight(_ sender: Any?)
    {
        self.floatBox = self.floatBox.outsideRight(base:self.baseBox)
    }

    
    
    // MARK: - event handling methods
    
    override func layout()
    {
        super.layout()

        self.updateBoxSize()
    }
    
    // MARK: - drawing methods

    override func draw(_ dirtyRect: NSRect)
    {
        super.draw(dirtyRect)

        NSGraphicsContext.saveGraphicsState()

        // Drawing base box
        NSColor.blue.set()
        NSBezierPath( rect: self.baseBox).stroke()

        // Drawing float box
        NSColor.red.set()
        NSBezierPath( rect: self.floatBox).stroke()

        NSGraphicsContext.restoreGraphicsState()
    }

    // MARK: - delegate/datasource methods
    
    // MARK: - accessor methods (in pairs)

    var baseBox: CGRect = CGRect.zero {didSet{self.setNeedsDisplay(self.bounds)}}
    var floatBox: CGRect = CGRect.zero{didSet{self.setNeedsDisplay(self.bounds)}}

    // MARK: - Utility methods

    // それぞれの箱の大きさは、Viewに依存する
    func updateBoxSize()
    {
        self.baseBox  = self.bounds.insetBy(dx: 50, dy: 50)
        self.floatBox = self.baseBox.insetBy(dx: 50, dy: 20)
    }
    
}
